<?php


// Manage the options page
function plastic_tunes_options() {

	foreach($_POST as $key => $val) {
		$_POST[$key] = stripslashes($val);
	}
	
	$dir = basename(dirname(__FILE__));
		
	global $wpdb;
	
	if(!empty($_POST['update'])) {
	
		update_option('plastic_tunes_sidebar_format_string', $_POST['sidebar_format_string']);		
		update_option('plastic_tunes_sidebar_count', intval($_POST['sidebar_count']));
		update_option('plastic_tunes_sidebar_outer_tag', ($_POST['sidebar_outer_tag']));
		update_option('plastic_tunes_sidebar_title', $_POST['sidebar_title']);
		update_option('plastic_tunes_togglesidebar_if', $_POST['togglesidebar_if']);
		update_option('plastic_tunes_togglesidebar_manual', $_POST['togglesidebar_manual']);
		update_option('plastic_tunes_sidegoogle', $_POST['sidegoogle']);
		/*update_option('plastic_tunes_player_state', $_POST['player_state']);*/
		
		update_option('plastic_tunes_index_count', intval($_POST['index_count']));
		update_option('plastic_tunes_index_title', $_POST['index_title']);
		update_option('plastic_tunes_indexgoogle', $_POST['indexgoogle']);
		update_option('plastic_tunes_tableclass', $_POST['tableclass']);
		update_option('plastic_tunes_skip_repeats', $_POST['skiprepeats']);
	
		update_option('plastic_tunes_min_user_level', intval($_POST['min_user_level']));
		update_option('plastic_tunes_post_password', $_POST['post_password']);
		
		update_option('plastic_tunes_format_date', $_POST['format_date']);
		update_option('plastic_tunes_db_timezone_offset', $_POST['db_timezone_offset']);
		update_option('plastic_tunes_srv_timezone_offset', $_POST['srv_timezone_offset']);
		update_option('plastic_tunes_flood_protection_secs', $_POST['flood_protection_secs']);
		update_option('plastic_tunes_userlist_text', $_POST['userlist_text']);
		
		update_option('plastic_tunes_showtitle', $_POST['showtitle']);
		update_option('plastic_tunes_showartist', $_POST['showartist']);
		update_option('plastic_tunes_showalbum', $_POST['showalbum']);
		update_option('plastic_tunes_showyear', $_POST['showyear']);
		update_option('plastic_tunes_showgenre', $_POST['showgenre']);
		update_option('plastic_tunes_showtrack', $_POST['showtrack']);
		update_option('plastic_tunes_showratings', $_POST['showratings']);
		update_option('plastic_tunes_showdate', $_POST['showdate']);
		update_option('plastic_tunes_showlastedtime', $_POST['showlastedtime']);
		update_option('plastic_tunes_showduration', $_POST['showduration']);
		update_option('plastic_tunes_shownav', $_POST['shownav']);		
		
				
		echo '<div class="updated"><p><strong>Options saved.</strong></p></div>';
	
	}
	
	$sidebar_format_string = get_option('plastic_tunes_sidebar_format_string');
	$sidebar_count = get_option('plastic_tunes_sidebar_count');
	$sidebar_outer_tag = get_option('plastic_tunes_sidebar_outer_tag');
	$sidebar_title = get_option('plastic_tunes_sidebar_title');
	$togglesidebar_if = get_option('plastic_tunes_togglesidebar_if');
	$togglesidebar_manual = get_option('plastic_tunes_togglesidebar_manual');	
	$sidegoogle = get_option('plastic_tunes_sidegoogle');
	//$playerstate = get_option('plastic_tunes_player_state');
	
	$index_count = get_option('plastic_tunes_index_count');
	$index_title = get_option('plastic_tunes_index_title');
	$indexgoogle = get_option('plastic_tunes_indexgoogle');
	$tableclass = get_option('plastic_tunes_tableclass');
	$skiprepeats = get_option('plastic_tunes_skip_repeats');	
	
	$min_user_level = get_option('plastic_tunes_min_user_level');
	$post_password = get_option('plastic_tunes_post_password');
		
	$format_date = get_option('plastic_tunes_format_date');
	$db_timezone_offset = get_option('plastic_tunes_db_timezone_offset');
	$srv_timezone_offset = get_option('plastic_tunes_srv_timezone_offset');
	$flood_protection_secs = get_option('plastic_tunes_flood_protection_secs');
	$userlist_text = get_option('plastic_tunes_userlist_text');
	
	$showtitle = get_option('plastic_tunes_showtitle');
	$showartist = get_option('plastic_tunes_showartist');
	$showalbum = get_option('plastic_tunes_showalbum');
	$showyear = get_option('plastic_tunes_showyear');
	$showgenre = get_option('plastic_tunes_showgenre');
	$showtrack = get_option('plastic_tunes_showtrack');
	$showratings = get_option('plastic_tunes_showratings');
	$showdate = get_option('plastic_tunes_showdate');
	$showlastedtime = get_option('plastic_tunes_showlastedtime');
	$showduration = get_option('plastic_tunes_showduration');
	$shownav = get_option('plastic_tunes_shownav');	
	

	$cur_time = $wpdb->get_row('SELECT UNIX_TIMESTAMP() AS thedate');
	$dbtime_plus_offset = $cur_time->thedate + ( $db_timezone_offset * 60 * 60 );
	$srvtime_plus_offset = time() + ( $srv_timezone_offset * 60 * 60 );
	
	if ( $post_password == "(change this)" ) {
		$input_txt_style = 'style="background-color: #FFAAAA;"';
	} else {
		$input_txt_style = 'style="background-color: #AAFFAA;"';
	}
	
	if ( $togglesidebar_if == 'Y' ) $togglesidebar_selected_if = 'checked';
	if ( $togglesidebar_manual == 'Y' ) $togglesidebar_selected_manual = 'checked';
	if ( $sidegoogle == 'Y' ) $sidegoogle_selected = 'checked';
	if ( $indexgoogle == 'Y' ) $indexgoogle_selected = 'checked';
	if ( $skiprepeats == 'Y' ) $skiprepeats_selected = 'checked';
	
	if ( $showtitle == 'Y' ) $showtitle_selected = 'checked';
	if ( $showartist == 'Y' ) $showartist_selected = 'checked';
	if ( $showalbum == 'Y' ) $showalbum_selected = 'checked';
	if ( $showyear == 'Y' ) $showyear_selected = 'checked';
	if ( $showgenre == 'Y' ) $showgenre_selected = 'checked';
	if ( $showtrack == 'Y' ) $showtrack_selected = 'checked';
	if ( $showratings == 'Y' ) $showratings_selected = 'checked';
	if ( $showdate == 'Y' ) $showdate_selected = 'checked';
	if ( $showlastedtime == 'Y' ) $showlastedtime_selected = 'checked';
	if ( $showduration == 'Y' ) $showduration_selected = 'checked';
	if ( $shownav == 'Y' ) $shownav_selected = 'checked';
		
	?> 
    
    <div class="wrap">
    
    <div  id="plasticwrap">
    <h2>PlasticTunes Options</h2>    
    
	<p>Click on the <img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="" border="0" align="absmiddle" /> icons for help. 
	For further instructions, consult the <a href="<?php echo PLASTIC_PATH; ?>/readme.htm">read me file</a>&nbsp;&raquo;</p>

	<form name="frm_options" method="post" action="<?php echo $_SERVER['REQUEST_URI']?>">
	
	<fieldset>
	
	<h3>Security Options:</h3>
	<blockquote>    

	<strong>Minimum User Level:</strong>
    <input type="text" size="2" maxlength="2" name="min_user_level" value="<?php echo (htmlentities($min_user_level)); ?>" />
    <img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp1');"
    onMouseOver="this.style.cursor='help'" border="0" /><br />
    <div id="hlp1" class="plastictip">Minimum level a user has to be in order to contribute songs.
	See <a href="http://codex.wordpress.org/User_Levels">here</a> for explanations.</div><br />
	
	<strong>Flood Protection:</strong> 
	<input type="text" size="2" name="flood_protection_secs" value="<?php echo (intval($flood_protection_secs)); ?>" /> Seconds
    <img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp2');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp2" style="display:none" class="plastictip">Minimum time allowed between posts per user. 
    It won't work properly if server and database time aren't correct (see options below)</div><br />
	
	<strong>Password hash:</strong>
	<input <?php echo $input_txt_style; ?> type="text" name="post_password" value="<?php echo (htmlentities($post_password)); ?>" />
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp3');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp3" style="display:none" class="plastictip">Leave this blank for no password protection. This is the password seed that will
	be added to the user_id to create a hash for each song submitter.
	Use the UserID and Password below for each user that is submitting music 
	infos to the DB. </div><br />
	
	<?php if ( $post_password != '') {
		// Get Users
		$userlist = $wpdb->get_results('
		SELECT u.id, u.display_name
		FROM '.$wpdb->prefix.'users u, '.$wpdb->prefix.'usermeta m
		WHERE u.id = m.user_id
		AND m.meta_key = "wp_user_level"
		AND m.meta_value >= "'. $min_user_level .'"
		ORDER BY id ASC');
	}

	if ( $userlist ) {
		?>
		<DIV STYLE="overflow: auto; width: 480px; height: 100px; border: 1px lightgray solid; padding:0px; margin: 0px">
		<TABLE cellspacing=0 cellpadding=2 id=header width=100%>
		<tr><th width=50 bgcolor="lightgrey">UserID</th>
		<th width=125 bgcolor="lightgrey" align="left">Name</th>
		<th bgcolor="lightgrey" align="left">Password</th>
		</tr>
		</TABLE>
		<TABLE cellspacing="2" cellpadding="0">
		<COL WIDTH=50><COL WIDTH=125><COL WIDTH=275>
		<?php foreach ( $userlist as $user ) {?>
        
			<tr>
			<td width=50 valign="top" nowrap align="center"><?php echo $user->id; ?></td>
			<td width=125 valign="top"><?php echo $user->display_name; ?></td>
			<td width=275 valign="top"><?php echo (md5( $user->id . $post_password )); ?></td>
			</tr>
		<?php } ?>				
		</table>
		</div>
		<br />
	<?php }?>
	
	</blockquote>
	</fieldset>
	<p class="submit">&nbsp;</p>
	<fieldset>
	<h3>DateTime Options:</h3>
	<blockquote>
		
	<strong>Database Timezone offset:</strong> 
	<input size="2" maxlength="2" type="text" name="db_timezone_offset" value="<?php echo (intval($db_timezone_offset)); ?>" /> Hours
	<br /><em>Current Database Time: <strong><?php echo (date( "D M j, Y h:i A" , $dbtime_plus_offset )); ?></strong></em><br /><br />

	<strong>Server Timezone offset:</strong> 
	<input size="2" maxlength="2" type="text" name="srv_timezone_offset" value="<?php echo (intval($srv_timezone_offset)); ?>" /> Hours
	<br /><em>Current Server Time: <strong><?php echo (date( "D M j, Y h:i A" , $srvtime_plus_offset )); ?></strong></em><br /><br />
	
	<strong>Date format string:</strong>
	<input type="text" name="format_date" value="<?php echo (htmlentities($format_date)); ?>" />
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp3b');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp3b" style="display:none" class="plastictip">Acceptable variables can be found <a href="http://dev.mysql.com/doc/mysql/en/date-and-time-functions.html#id3101576">here.</a></div><br />
	</blockquote>
	</fieldset>
	<p class="submit">&nbsp;</p>
	<fieldset>	
	<h3>Sidebar Options:</h3>	
	<blockquote>
	
	<strong>Title:</strong><br />
	<textarea name="sidebar_title" rows="3" cols="60"><?php echo (htmlentities($sidebar_title)); ?></textarea>
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp4');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp4" style="display:none" class="plastictip">Title appearing above the songs displayed in the sidebar. The sole 
	acceptable variable here is <font color="#003399">%name%</font> (which returns the name of the user.)<br/>
	In this field as in the next ones, no pre-formatting is applied outside of what
	you enter here, leaving you free to use your own css styles and html elements.
	Please note: the widget title option overrides this one. Leave that one empty to keep using this even with the widget. 
	Also note that overriding the widget title means also overriding the default elements before and after the widget, 
	such as 'h2' or 'li'. Remember to add them manually in this field and to close them in the 'Closing elements' field below.</div><br />

	<strong>Format string:</strong><br />
	<textarea name="sidebar_format_string" id="sidebar_format_string" rows="5" cols="60"><?php echo (htmlentities($sidebar_format_string)); ?></textarea>
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp5');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp5" style="display:none" class="plastictip">The actual list of music items for the sidebar. <br/>Acceptable variables are:<br/><br/>
	<font color="#003399">%artist%</font> - Artist<br />
	<font color="#003399">%album%</font> - Album<br />
	<font color="#003399">%title%</font> - Title<br />
	<font color="#003399">%year%</font> - Year<br />
	<font color="#003399">%rating%</font> - Rating<br />
	<font color="#003399">%genre%</font> - Genre<br />
	<font color="#003399">%track%</font> - Track number<br />
	<font color="#003399">%duration%</font> - The duration of the piece<br />
	<font color="#003399">%created%</font> - the time and date the music was played. Returns "Playing now" as long
	as the music item plays.<br /> 
	<font color="#003399">%time_ago%</font> - how long ago the music was played - i.e. 17 minutes. "Played" and "ago"
	are automatically added around this variable. If the music item is still playing instead, 
	the entire reference will be replaced by "Playing now".</div><br />
	
	<strong>Closing element(s):</strong> 
	<input type="text" name="sidebar_outer_tag" value="<?php echo (htmlentities($sidebar_outer_tag)); ?>" />
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp6');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp6" style="display:none" class="plastictip">Closing tag that comes after the items, needed in case you opened a <br/>
    'span' or 'ul' or other tag in the title. 
	You can enter all the tag you need in sequence. You should leave this empty if the title filed is also empty 
	AND you use the widget to display the sidebar element.</div><br />
	
	<strong>Date format on Sidebar:</strong> 
	<input type="text" name="format_date" value="<?php echo $format_date; ?>" />
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp7');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp7" style="display:none" class="plastictip">If you choose to display the date (%created%) on the sidebar, <br/>
    this is the format it will use. </div><br />

	<strong>Add google links:</strong> 
	<input type="checkbox" name="sidegoogle" value="Y" <?php echo $sidegoogle_selected; ?>>
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp8');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp8" style="display:none" class="plastictip">Adds useful google links to Artists and albums.</div><br />
	
	<strong>Songs to display a time:</strong> 
	<input size="3" maxlength="4" type="text" name="sidebar_count" value="<?php echo (intval($sidebar_count)); ?>" />
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp9');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp9" style="display:none" class="plastictip">The maximum number of songs that will be displayed on the sidebar.
	Entering 0 will also not display the text and closing element, but it will continue
	to insert music items in the database (as opposed to the "Manually disable" option below)</div><br />
	
	<strong>Hide the sidebar element if the player stops:</strong> 
	<input type="checkbox" name="togglesidebar_if" value="Y" <?php echo $togglesidebar_selected_if; ?>>
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp10');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp10" style="display:none" class="plastictip">Causes the plugin to stop collecting data and hides the music infos from the sidebar,
	including title and outer element. This only happens in the event of the player being stopped,
	exited or paused, or when "artist" or "title" records return empty.</div><br />
	
	<strong>Manually disable the sidebar element:</strong> 
	<input type="checkbox" name="togglesidebar_manual" value="Y" <?php echo $togglesidebar_selected_manual; ?>>
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp11');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp11" style="display:none" class="plastictip">When checked, all the plugin elements will be hidden from the sidebar. Also, nothing of what
	the player plays will be stored.</div><br />
	
	</blockquote>
	</fieldset>
	<p class="submit">&nbsp;</p>
	<fieldset>	
	<h3>Index page options:</h3>
	<blockquote>

	<strong>Title:</strong><br />
	<textarea name="index_title" rows="3" cols="60"><?php echo (htmlentities($index_title)); ?></textarea>
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp12');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp12" style="display:none" class="plastictip">The text that is displayed before the Index of all the music items.
	Acceptable variables: %name%. This title must be kept without opened tags, 
	since there is no "closing element" avaliable, unlike for the sidebar.</div><br />
	
	<strong>Show table elements:</strong> 
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp13');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp13" style="display:none" class="plastictip">The list of music items for the index page is generated in form of a table.
	Here you can select which variables should appear in the table colums, and whether or not to
	display browsing commands for next and previous pages.</div><br />

	<input type="checkbox" name="showtitle" value="Y" <?php echo $showtitle_selected; ?>> Song Title<br />
	<input type="checkbox" name="showartist" value="Y" <?php echo $showartist_selected; ?>> Artist<br />
	<input type="checkbox" name="showalbum" value="Y" <?php echo $showalbum_selected; ?>> Album<br />
	<input type="checkbox" name="showyear" value="Y" <?php echo $showyear_selected; ?>> Year<br />
	<input type="checkbox" name="showgenre" value="Y" <?php echo $showgenre_selected; ?>> Genre<br />
	<input type="checkbox" name="showtrack" value="Y" <?php echo $showtrack_selected; ?>> Track<br />
	<input type="checkbox" name="showratings" value="Y" <?php echo $showratings_selected; ?>> Rating (if available)<br />
	<input type="checkbox" name="showdate" value="Y" <?php echo $showdate_selected; ?>> Date Played<br />
	<input type="checkbox" name="showlastedtime" value="Y" <?php echo $showlastedtime_selected; ?>> Time passed since played<br />
	<input type="checkbox" name="showduration" value="Y" <?php echo $showduration_selected; ?>> Duration of the piece<br />
	<input type="checkbox" name="shownav" value="Y" <?php echo $shownav_selected; ?>> Navigation (Next, Previous)<br /><br />
	
	<strong>CSS file:</strong>
	<input size="50" type="text" name="tableclass" value="<?php echo $tableclass; ?>" />
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp14');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp14" style="display:none" class="plastictip">Here you can indicate the path to a CSS file that will define the aspect of the table.
	The css file should define:<br />
	<font color="#CC3366">.plastic_table_class</font> - a class for the table in general;<br />
	<font color="#CC3366">.plastic_header_class</font> - a class for the column headers in general;<br />
	<font color="#CC3366">.plastic_th_class</font> - a class for every single column header;<br />
	<font color="#CC3366">.plastic_td_class</font> - a class for every cell;<br />
	<font color="#CC3366">.plastic_odd_record</font> - a class for the odd records;<br />
	<font color="#CC3366">.plastic_even_record</font> - a class for the even records;<br /><br />
	By default a simple CSS file with these classes is included with the plugin. 
	If you'd rather add the classes to your main css file, or if you don't want 
	to use any css file at all, just leave this field empty.</div><br />	
	
	<strong>Add google links:</strong> 
	<input type="checkbox" name="indexgoogle" value="Y" <?php echo $indexgoogle_selected; ?>>
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp15');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp15" style="display:none" class="plastictip">Adds useful google links to Artists and albums.</div><br />
	
	<strong>Userlist Text:</strong> 
	<input size="50" type="text" name="userlist_text" value="<?php echo (htmlentities($userlist_text)); ?>" />
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp16');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp16" style="display:none" class="plastictip">If no USERID is specified for the index page 
    (on how, see <a href="<?php echo PLASTIC_PATH; ?>/readme.htm">read me</a> file), 
	this text will be displayed above a list of active users.</a></div><br />
	
	<strong>Songs to display per page:</strong> 
	<input type="text" name="index_count" value="<?php echo (intval($index_count)); ?>" />
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp17');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp17" style="display:none" class="plastictip">The maximum number of songs that will be displayed per page. Must be greater than 0.</div><br />
	
	<strong>Skip duplicate entries:</strong> 
	<input type="checkbox" name="skiprepeats" value="Y" <?php echo $skiprepeats_selected; ?>>
	<img src="<?php echo PLASTIC_PATH; ?>/help.png" alt="click for help" onclick="return toggleMe('hlp18');" 
    onMouseOver="this.style.cursor='help'" border="0" /><br />    
	<div id="hlp18" style="display:none" class="plastictip">Since we all listen to certain music pieces more than once in our days, here you can avoid 
	duplicate entries to show up in the table. Obviously they will be collected in your database just the same.
	Identical Artist, Title and Album are used as a match criteria.</div><br />
	
	</blockquote>
	</fieldset>
	<input type="hidden" name="update" value="yes" />
	<p class="submit"><input type="submit" value="Update Options &raquo;" /></p>
	</form></div>
	
	<?php plastic_block();

}






// manages the list of music entries in the admin area
function plastic_tunes_manage() {

	global $wpdb;
	
	$dir = basename(dirname(__FILE__));
	$path_to_plugin = trailingslashit(get_settings('siteurl')) . 'wp-content/plugins/' . $dir;


	foreach($_REQUEST as $key => $val) {
		${"plastic_tunes_".$key} = stripslashes($val);
	}
	
	if($_POST['action'] == 'delete') {

		$wpdb->query('
		DELETE FROM '.$wpdb->prefix.'plastic_tunes
		WHERE id = '. (int) $_POST['song_id'].'');

		echo '<div class="updated"><p><strong>The music item has been deleted successfully.</strong></p></div>';

	}
	
	if($_POST['action'] == 'purge') {
		if ( $_POST['clear_db'] && $_POST['clear_db'] == 'Y' && $_POST['clear_db_uid'] != "" ) {
			if ( $_POST['clear_db_uid'] == "ALL" ) {
				$cleardata = $wpdb->query('DELETE FROM '.$wpdb->prefix.'plastic_tunes' );
				$purge_msg = 'Delete music data for all Users - '. $cleardata .' records deleted.';
			}
			else {
				$cleardata = $wpdb->query('DELETE * FROM '.$wpdb->prefix.'plastic_tunes WHERE user_id = '. intval($_POST['clear_db_uid']) );
				$purge_msg = 'Purging song data for User#'. $_POST['clear_db_uid'] .' - '. $cleardata .' records deleted.';
			}
		echo '<div class="updated"><p><strong>'. $purge_msg .'</strong></p></div>';
		}
	}		
		
	$index_count = get_option('plastic_tunes_index_count');
	$sql_limit = $index_count + 1;
		
	if ( !$plastic_tunes_startrow ) $plastic_tunes_startrow = 0;
	$songs = $wpdb->get_results('
	SELECT user_id AS user_id, id AS song_id, title AS title, artist AS artist, album AS album, year AS year, genre AS genre, 
	track AS track, rating as rating, DATE_FORMAT(created, "%d %b %y") AS created, UNIX_TIMESTAMP(created) AS time_stamp, duration AS duration
	FROM '.$wpdb->prefix.'plastic_tunes
	ORDER BY time_stamp desc	
	LIMIT '. $plastic_tunes_startrow .', '. $sql_limit .'');

	echo '<div class="wrap">

		<h2>Plastic Tunes</h2>
		<script language="JavaScript"><!--
		function mTsetAction(obj, action) {
		 obj.action.value = action;
		 obj.submit();
		}
		//--></script>

		';

		if ( $songs ) {
			echo 'Purge DB: <input type="checkbox" name="clear_db" value="Y"> User ID: <input type="text" size="4" name="clear_db_uid" value="" />
			<input type="button" value="Delete" onClick="if( confirm(\'Are you sure you wish to delete these music items permanently?\')) 
			mTsetAction(this.form, \'purge\');" />
			<br />Check the above box to delete all music data for a specific user, or enter "all" to delete ALL user data.
			<p />';
		}
		
		echo '<table width="100%" cellpadding="3" cellspacing="3"> 

			<tr>
				<th scope="col">SongID</th>
				<th scope="col">UserID</th>
				<th scope="col">Date played</th>
				<th scope="col">Artist</th>
				<th scope="col">Album</th>
				<th scope="col">Title</th>
				<th scope="col">Ratings</th>
				<th scope="col">Year</th>
				<th scope="col">Track</th>
				<th scope="col">Genre</th>
				<th scope="col">Duration</th>
				<th scope="col"></th>
			</tr>
	';

	if ( $songs ) {
		$i = 0;
	
		foreach($songs as $song) {
	
			$alt = ($i % 2 == 0) ? ' class="alternate"' : '';
			echo '
				<tr'.$alt.'><form name="songs" method="post">
				<input type="hidden" name="page" value="plastic_functions.php"><input type="hidden" name="action" value="delete">
					<td><small><input type="hidden" name="song_id" value="'.$song->song_id.'" />'.$song->song_id.'</small></td>
					<td><small>'.$song->user_id.'</small></td>
					<td><small>'.$song->created.'</small></td>
					<td><small>'.$song->artist.'</small></td>
					<td><small>'.$song->album.'</small></td>
					<td><small>'.$song->title.'</small></td>
					<td><small>'.$song->ratings.'</small></td>
					<td><small>'.$song->year.'</small></td>
					<td><small>'.$song->track.'</small></td>
					<td><small>'.$song->genre.'</small></td>
					<td><small>'.$song->duration.'</small></td>
					<td><small><input type="button" value="Delete" 
					onClick="if( confirm(\'Are you sure you wish to delete this music item permanently?\')) mTsetAction(this.form, \'delete\');" /></small></td>
				</tr>
			</form>
			';
	
			$i++;
	
		}	
		
		// generating navigator
		$plastic_tunes_startrow_plus = $plastic_tunes_startrow + $index_count;
		$plastic_tunes_startrow_minus = $plastic_tunes_startrow - $index_count;
		
		echo '<tr>';
		echo '<td colspan="12" align="center">';					
		$thispage = $_SERVER["REQUEST_URI"];		
		
		/* first I check if a "&startrow" variable is present in the URI, in which case
		i have to strip it from the URI otherwise, because of the way the output is conceived below,
		in the next page I'd have two "&startrow=&startrow=" in the same URI. */										
		if (stristr($thispage,"&startrow") != FALSE) {
			$novars = str_replace(stristr($thispage,"&startrow"), "", $thispage);
			$connect = "&startrow=";
		}
		
		/*  then there's the case where a "&startrow" is NOT present in the URI */					
		else {
		
			/* if any other "&" is present in the URI that is not "&startrow", 
			it is safe to use "&" to connect "startrow" */						
			if (stristr($thispage,"&") != FALSE ) {
			$novars = $thispage;
			$connect = "&startrow=";
			}
						
			/*if no other "&" is present*/						
			else {
			
				/* in case that a "?startrow" is present (this could happen, with non-default permalinks, 
				and with a "user_id" variable sent in via the tag instead than via the URI)
				I will strip it off the URI and connect the next "startrow" with a "?" */							
				if (stristr($thispage,"?startrow") != FALSE) {
					$novars = str_replace(stristr($thispage,"?startrow"), "", $thispage);
					$connect = "?startrow=";
				}
			
				/* and if no "?startrow" is present */							
				else {
				
					/* if there are any "?" left in the URI, like default permalinks or anything else,
					it is safe to use "&startrow"  */								
					if (stristr($thispage,"?") != FALSE ) {
					$novars = $thispage;
					$connect = "&startrow=";
					}
					
					/* finally, if no "?" is present, I connect "startrow" with a "?" */								
					else {
					$novars = $thispage;
					$connect = "?startrow=";
					}
				}
			}
		}		
		
		echo '<ol style="list-style-type: none;margin: 0;padding: 0"><li style="list-style-type: none;float: left;width: 10em;text-indent: 0px;">';
		
		if ( $i-1 == $index_count ) {				
		echo '<br/><a href="'. $novars . $connect . $plastic_tunes_startrow_plus .'">&#8249; previous '. $index_count . '</a><br/></li>';
			if ( $plastic_tunes_startrow > 1 ) {
				echo '<li style="list-style-type: none;float:right;width: 10em;text-indent: 0px;">
				<br/><a href="'. $novars . $connect . $plastic_tunes_startrow_minus .'">next '. $index_count . ' &#8250;</a><br/></li>';
			}				
		} 
		
		else {			
			if ($plastic_tunes_startrow > $i-1) {
			echo '<li style="float:right;width: 10em;">
			<br/><a href="'. $novars . $connect . $plastic_tunes_startrow_minus .'">next '. $index_count . ' &#8250;</a><br/></li>';
			}
		}
		
		echo '</td></tr>';		
		
	}
	else {
		echo '<tr><td colspan="12">No songs to display</td></tr>';
	}
	echo '
		</table>
	</div>';
}




?>